package com.example.backend;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import com.example.backend.categories.model.CategorieEntity;
import com.example.backend.categories.service.CategorieService;
import com.example.backend.favorites.model.FavoriteEntity;
import com.example.backend.favorites.service.FavoriteService;
import com.example.backend.movies.model.MovieEntity;
import com.example.backend.movies.service.MovieService;
import com.example.backend.users.service.UserService;

// create lab 2

@SpringBootApplication
public class BackendApplication implements CommandLineRunner {

	private final Logger _logger = LoggerFactory.getLogger(BackendApplication.class);
	private final UserService userService;
	private final CategorieService categorieService;
	private final MovieService movieService;
	private final FavoriteService favoriyService;

	public BackendApplication(UserService userService,
			CategorieService categorieService,
			MovieService movieService,
			FavoriteService favoriyService) {
		this.userService = userService;
		this.categorieService = categorieService;
		this.favoriyService = favoriyService;
		this.movieService = movieService;
	}

	public static void main(String[] args) {
		SpringApplication.run(BackendApplication.class, args);
	}

	@Override
	public void run(String... args) throws Exception {

		// final var admin = new UserEntity(null, "elena", "1234");
		// final var vasya = new UserEntity(null, "vasya", "1234");

		// final var u1 = new UserEntity(null, "1", "1234");
		// final var u2 = new UserEntity(null, "2", "1234");
		// final var u3 = new UserEntity(null, "3", "1234");
		// final var u4 = new UserEntity(null, "4", "1234");
		// final var u5 = new UserEntity(null, "5", "1234");
		// final var u6 = new UserEntity(null, "6", "1234");
		// final var u7 = new UserEntity(null, "7", "1234");

		// final var cat1 = new CategorieEntity(null, "Драма", null);
		// final var cat2 = new CategorieEntity(null, "Комедия", null);
		// final var cat3 = new CategorieEntity(null, "Хоррор", null);
		// final var cat4 = new CategorieEntity(null, "Мультитк", null);

		final var cat5 = new CategorieEntity(null, "Опера", null);

		final var mov1 = new MovieEntity(null, cat5, "певчая птичка", "null", "null", null);

		// admin.setRole(UserRole.ADMIN);
		// vasya.setRole(UserRole.USER);

		// u1.setRole(UserRole.USER);
		// u2.setRole(UserRole.USER);
		// u3.setRole(UserRole.USER);
		// u4.setRole(UserRole.USER);
		// u5.setRole(UserRole.USER);
		// u6.setRole(UserRole.USER);
		// u7.setRole(UserRole.USER);

		// userService.create(admin);
		// userService.create(vasya);
		// userService.create(u1);
		// userService.create(u2);
		// userService.create(u3);
		// userService.create(u4);
		// userService.create(u5);
		// userService.create(u6);
		// userService.create(u7);

		// categorieService.create(cat1);
		// categorieService.create(cat2);
		// categorieService.create(cat3);
		// categorieService.create(cat4);
		// categorieService.create(cat5);
		// movieService.create(mov1);

		// movieService.get(98));
		// for (var fav : favoriyService.getAll(2)) {
		// favoriyService.delete(fav.getId());
		// }
		// favoriyService.create(new FavoriteEntity(null, userService.get(2),
		// movieService.get(98)));

		_logger.info("The program is started, coun favs is " + favoriyService.getAll(2).size());
	}

}
