package com.example.backend.categories.api;

import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import com.example.backend.categories.model.CategorieEntity;
import com.example.backend.categories.service.CategorieService;

import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;

@Controller
@RequestMapping(CategorieUserController.URL)
public class CategorieUserController {

    public static final String URL = "/categories";
    private static final String CATEGORIE_VIEW = "categories";

    private final CategorieService categorieService;
    private final ModelMapper modelMapper;

    public CategorieUserController(CategorieService categorieService, ModelMapper modelMapper) {
        this.categorieService = categorieService;
        this.modelMapper = modelMapper;
    }

    private CategorieDTO toDto(CategorieEntity entity) {
        return modelMapper.map(entity, CategorieDTO.class);
    }

    @GetMapping()
    public String getAll(Model model) {
        model.addAttribute(
                "categories",
                categorieService.getAll().stream()
                        .map(this::toDto)
                        .toList());
        return CATEGORIE_VIEW;
    }
}
