package com.example.backend.favorites.repository;

import java.util.Optional;
import java.util.List;
import org.springframework.data.repository.CrudRepository;

import com.example.backend.favorites.model.FavoriteEntity;

public interface FavoriteRepository extends CrudRepository<FavoriteEntity, Integer> {

    List<FavoriteEntity> findByUserId(Integer userId);

    FavoriteEntity findByUserIdAndMovieId(Integer userId, Integer movieId);

    Optional<FavoriteEntity> findOneByUserIdAndId(Integer userId, Integer id);

    Optional<FavoriteEntity> deleteByMovieId(Integer movieId);

    Optional<FavoriteEntity> deleteByUserId(Integer user);

}
