package com.example.backend.movies.repository;

import java.util.Optional;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

import com.example.backend.movies.model.MovieEntity;

public interface MovieRepository
        extends CrudRepository<MovieEntity, Integer>, PagingAndSortingRepository<MovieEntity, Integer> {

    Optional<MovieEntity> findByNameIgnoreCase(String name);

    Optional<MovieEntity> findByCategorieIdAndId(Integer categorieId, Integer id);

    Page<MovieEntity> findByCategorieId(Integer categorieId, Pageable page);

    Optional<MovieEntity> deleteByCategorieId(Integer categorieId);

    @Query("SELECT COUNT(DISTINCT v.user.id) FROM ViewedEntity v WHERE v.movie.id = :movieId")
    Integer getCountViews(@Param("movieId") Integer movieId);

}