package com.example.backend.viewed.repository;

import java.util.Optional;
import java.util.List;

import org.springframework.data.repository.CrudRepository;

import com.example.backend.viewed.model.ViewedEntity;

public interface ViewedRepository extends CrudRepository<ViewedEntity, Integer> {

    List<ViewedEntity> findByUserId(Integer userId);

    Optional<ViewedEntity> findOneByUserIdAndId(Integer userId, Integer id);

    ViewedEntity findByUserIdAndMovieId(Integer userId, Integer movieId);

    Optional<ViewedEntity> deleteByMovieId(Integer movieId);

    Optional<ViewedEntity> deleteByUserId(Integer user);

}
